#include "Board.h"


Board::Board(void)
{
	// z̏l-1(uĂȂ)ŏ
	for(int i = 0; i < 8; ++i) {
		for(int j = 0; j < 8; ++j) {
			cellInfo[i][j] = -1;
		}
	}
	// Ֆʍ쐬
	setupBoard();
}


Board::~Board(void)
{
}

void Board::entry(fk_Scene *argScene)
{
	argScene->entryModel(&blockModel);
	argScene->entryModel(&gridModel);

	return;
}

void Board::remove(fk_Scene *argScene)
{
	argScene->removeModel(&blockModel);
	argScene->removeModel(&gridModel);

	return;
}

void Board::setupBoard(void)
{
	// ̂̐ݒ
	block.makeBlock(90.0, 5.0, 90.0),
	blockModel.setShape(&block);
	blockModel.setMaterial(Green);
	blockModel.glTranslate(0.0, -2.75, 0.0);

	// Obh
	fk_Vector	posA, posB;
	for(int i = 0; i < 9; ++i) {
		posA.set(-40.0 + i*10.0, 0.0, -40.0);
		posB.set(-40.0 + i*10.0, 0.0,  40.0);
		grid.pushLine(posA, posB);
		posA.set(-40.0, 0.0, -40.0 + i*10.0);
		posB.set( 40.0, 0.0, -40.0 + i*10.0);
		grid.pushLine(posA, posB);
	}
	gridModel.setShape(&grid);
	gridModel.setLineColor(0.0, 0.0, 0.0);
	gridModel.setWidth(2.0);

	return;
}

int Board::checkCell(const fk_Vector &argPos, fk_Vector *argAdjustPos)
{
	// ␳̗
	int tmpX = (int)argPos.x;
	int tmpZ = (int)argPos.z;
	if(tmpX > 0) {
		argAdjustPos->x = tmpX - (tmpX % 10) + 5;
	} else {
		argAdjustPos->x = tmpX - (tmpX % 10) - 5;
	}
	if(tmpZ > 0) {
		argAdjustPos->z = tmpZ - (tmpZ % 10) + 5;
	} else {
		argAdjustPos->z = tmpZ - (tmpZ % 10) - 5;
	}
	argAdjustPos->y = 0.0;

	// -35.0`35.0̎l0`7ɒ(z̗vfԍƂėp)
	int idX = calcID(argAdjustPos->x);
	int idY = calcID(argAdjustPos->z);

	// ͈͊O`FbN
	if(idX < 0 || idX > 7 || idY < 0 || idY > 7) {
		return -2;
	}

	// ɒuĂ邩`FbN
	if(cellInfo[idX][idY] >= 0) {
		return cellInfo[idX][idY];
	}

	return -1;
}

void Board::setStoneID(const fk_Vector &argPos, int argID)
{
	// -35.0`35.0̎l0`7ɒ(z̗vfԍƂėp)
	int idX = calcID(argPos.x);
	int idY = calcID(argPos.z);

	// ͈͊O`FbN
	if(idX < 0 || idX > 7 || idY < 0 || idY > 7) {
		return;
	}

	cellInfo[idX][idY] = argID;

	return;
}

// -35`35̍Wl0`7ɕϊ
int Board::calcID(double value)
{
	return ((int)value + 35)/10;
}
