#include "FrameController.h"

bool ALSleep (float duration);

//======================================================
//RXgN^
//======================================================
fkut_FrameController::fkut_FrameController(unsigned long dwFps, bool bFrameSkip)
{
	memset(this,0,sizeof(fkut_FrameController));
	m_bInit = 1;
	m_bFrameSkip = bFrameSkip;
	SetFPS(dwFps);
#ifdef WIN32
	timeBeginPeriod(1);
#endif
}


//======================================================
//fXgN^
//======================================================
fkut_FrameController::~fkut_FrameController()
{
#ifdef WIN32
	timeEndPeriod(1);
#endif
}

void fkut_FrameController::SleepOneMSec(void)
{
#ifdef WIN32
	Sleep(1);
#else
	//Fl::wait(0.001);
#endif
	return;
}

//======================================================
//ŎԐ܂B
//======================================================
void fkut_FrameController::TimeRegular()
{
	m_dwFrameCount++;

	
	if(m_bInit == 1)
	{
		m_dwLastMinitues = fk_Window::getNow();
		m_bInit = 0;
		m_bDrawFlag = 1;
		return;
	}

	if(m_bFrameSkip == 1 && fk_Window::getNow()  > (unsigned long)((m_dwFrameCount + 1) * m_fFrameTime + m_dwLastMinitues))
	{
		m_bDrawFlag = 0;
		m_dwSkipCount++;
	}
	else
	{
		unsigned long dwTime = (unsigned long)(m_dwFrameCount * m_fFrameTime + m_dwLastMinitues);
#ifdef WIN32
		while(fk_Window::getNow() <= dwTime)
		{
			SleepOneMSec();
		}
#else
        unsigned long now = fk_Window::getNow();
        if(now <= dwTime) {
            ALSleep(0.001f*float(dwTime-now));
        }
#endif
		m_bDrawFlag = 1;
	}

	
	if(fk_Window::getNow() - m_dwLastMinitues >= 1000)
	{
		m_dwLastMinitues = fk_Window::getNow();
		m_dwFrameRate = m_dwFrameCount;
		m_dwFrameCount = 0;
		m_dwSkipRate = m_dwSkipCount;
		m_dwSkipCount = 0;
	}
}

//==================================================
//őt[[g𑪒肵܂B
//==================================================
void fkut_FrameController::Measure()
{
	m_dwFrameCount++;
	m_bDrawFlag = 1;
	if(fk_Window::getNow() - m_dwLastMinitues >= 1000)
	{
		m_dwLastMinitues = fk_Window::getNow();
		m_dwFrameRate = m_dwFrameCount;
		m_dwFrameCount = 0;
		m_dwSkipRate = m_dwSkipCount;
		m_dwSkipCount = 0;
	}	
}

//======================================================
//t[XLbv邩Ȃݒ肵܂B
//======================================================
void fkut_FrameController::OnFrameSkip(bool bFrameSkip)
{
	m_bFrameSkip = bFrameSkip;
}

//======================================================
//FPSݒ肷B
//======================================================
void fkut_FrameController::SetFPS(unsigned long fps)
{
	m_fFrameTime = 1000.0f / fps;
}


//======================================================
//Ńt[[g擾܂B
//======================================================
unsigned long fkut_FrameController::GetFrameRate()
{
	return m_dwFrameRate;
}

//======================================================
//ŃXLbv[g擾܂B
//======================================================
unsigned long fkut_FrameController::GetSkipRate()
{
	return m_dwSkipRate;
}

//======================================================
//`悷邩Ȃ𔻒
//======================================================
bool fkut_FrameController::GetDrawFlag()
{
	return m_bDrawFlag;
}
