#include "OthelloApp.h"

#include <iostream>
#include <fstream>
#include <string>
#include "FKUT/Misc.h"


OthelloApp::OthelloApp(Fl_Window *argMainWin, fk_Window *argDrawWin)
	: fkut_AppBase(argMainWin, argDrawWin), tb(argDrawWin, &camera)
{
	// EBhEփV[o^
	drawWin->setScene(&scene);
}

OthelloApp::~OthelloApp(void)
{
	// EBhEV[̓o^
	drawWin->setScene(NULL);
}

void OthelloApp::init(void)
{
	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.getMaterial()->setDiffuse(1.0, 1.0, 1.0);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// zu4(ꎞIuWFNg)
	makeStone(fk_Vector( 5.0, 0.0,  5.0));
	makeStone(fk_Vector(-5.0, 0.0,  5.0));
	makeStone(fk_Vector(-5.0, 0.0, -5.0));
	makeStone(fk_Vector( 5.0, 0.0, -5.0));

	// effBXvCXgɓo^
	scene.setBlendStatus(true);
	scene.setBGColor(0.5, 0.5, 0.5);
	scene.entryCamera(&camera);
	scene.entryModel(&lightModel);
	// NX̂Ńo֐oRŃGg[
	board.entry(&scene);

	// eLXgEl\p
	textSpr.initFont("C:/Windows/Fonts/Meiryo.ttc");
	textSpr.drawText("\̈");
	textSpr.entryFirst(drawWin, &scene, &camera);
	textSpr.setPositionLT(-WINDOW_WIDTH*0.5, WINDOW_HEIGHT*0.5);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 100.0, 100.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	return;
}

// NbNꏊ̍WlԂ(ՖʂɊւ鏈Board::checkCell())
fk_Vector OthelloApp::clickProc(void)
{
	fk_Plane	plane;
	fk_Vector	winPos, projPos;

	plane.setPosNormal(fk_Vector(0.0, 0.0, 0.0), fk_Vector(0.0, 1.0, 0.0));
	winPos = eveMan.getMousePosition();
	drawWin->getProjectPosition(winPos.x, winPos.y, &plane, &projPos);

	return projPos;
}

// ΂u
int OthelloApp::makeStone(const fk_Vector &argPos)
{
	// bIɁAԖڂ͍AԖڂ͔ɂ
	if(stoneArray.size() % 2 == 0) {
		stoneArray.push_back(new Stone(ST_BLACK));
	} else {
		stoneArray.push_back(new Stone(ST_WHITE));
	}
	stoneArray.back()->setPosition(argPos);
	stoneArray.back()->entry(&scene);

	// Ֆʃf[^ɉԖڂ̐΂ûZbg
	board.setStoneID(argPos, stoneArray.size()-1);

	return (int)stoneArray.size();
}

// t[̏
bool OthelloApp::update(void)
{
	// J̉]
	tb.update();
	// Cg̉]
	lightModel.glRotateWithVec(0.0, 0.0, 0.0, fk_Y, 0.01);

	// }EXꂽ炻̏ꏊɐ΂u
	if(eveMan.getMouseStatus(FK_MOUSE1) == FKUT_SW_DOWN) {
		fk_Vector adjustPos;
		// Ԓl̒lɉď𕪊
		int result = board.checkCell(clickProc(), &adjustPos);
		switch(result) {
		case -1:
			makeStone(adjustPos);
			putMessage(fk_StrPrintf("(%d, %d)ɒu܂B",
				board.calcID(adjustPos.x), board.calcID(adjustPos.z)));
			break;
		case -2:
			putMessage("Ֆʂ̊Oɂ͒u܂B");
			break;
		default:
			stoneArray[result]->reverse();
			putMessage("ɒuĂ܂B");
			break;
		}
	}
	// t@C̏o(F2L[)Ɠ(F1L[)̃eXg
	if(eveMan.getSpecialKeyStatus(FK_F1) == FKUT_SW_DOWN) {
		if(loadState()) {
			putMessage("Load success.");
		} else {
			putMessage("Load failed.");
		}
	}
	if(eveMan.getSpecialKeyStatus(FK_F2) == FKUT_SW_DOWN) {
		if(saveState()) {
			putMessage("Save success.");
		} else {
			putMessage("Save failed.");
		}
	}

	return true;
}

bool OthelloApp::saveState(void)
{
	ofstream	out_file("fileIO.txt");

	if(!out_file.is_open()) return false;

	out_file << "o͂̃eXg" << endl;
	out_file << "hogehoge,hugahuga,hoehoe" << endl;

	out_file.close();

	return true;
}

bool OthelloApp::loadState(void)
{
	ifstream		in_file("fileIO.txt");
	string			str;
	vector<string>	strSplit;

	if(!in_file.is_open()) return false;

	while(getline(in_file, str)) {
		cout << str << endl;
		strSplit = fk_StrSplit(str, ",");
		for(int i = 0; i < (int)strSplit.size(); ++i) {
			cout << strSplit[i] << endl;
		}
	}

	in_file.close();

	return true;
}

void OthelloApp::putMessage(string argText)
{
	textSpr.drawText(argText, true);
	textSpr.setPositionLT(-WINDOW_WIDTH*0.5, WINDOW_HEIGHT*0.5);

	return;
}
