#include "Stone.h"


Stone::Stone(StoneColor argColor) : color(argColor)
{
	// ΂̊{`̓vY1g񂷂Ƃɂ
	stoneShape.makePrism(32, 4.0, 4.0, 0.25);
	// fɌ`ƃXP[Zbg
	blackModel.setShape(&stoneShape);
	blackModel.setSmoothMode(true);
	blackModel.setMaterial(GlossBlack);
	blackModel.glMoveTo(0.0, 0.0, -0.25);
	whiteModel.setShape(&stoneShape);
	whiteModel.setSmoothMode(true);
	whiteModel.setMaterial(White);
	blackModel.glMoveTo(0.0, 0.0,  0.25);
	
	blackModel.setParent(&stoneModel, true);
	whiteModel.setParent(&stoneModel, true);

	if(argColor == ST_BLACK) {
		stoneModel.glVec(0.0,  1.0, 0.0);
	} else if(argColor == ST_WHITE) {
		stoneModel.glVec(0.0, -1.0, 0.0);
	} else {
		fl_alert("Invalid color!");
	}

	return;
}

Stone::~Stone(void)
{
}

void Stone::reverse(StoneColor argColor)
{
	if(argColor == ST_BLACK) {
		color = ST_BLACK;
		stoneModel.glVec(0.0,  1.0, 0.0);
	} else if(argColor == ST_WHITE) {
		color = ST_WHITE;
		stoneModel.glVec(0.0, -1.0, 0.0);
	} else {
		if(color == ST_BLACK) {
			color = ST_WHITE;
			stoneModel.glVec(0.0, -1.0, 0.0);
		} else if(color == ST_WHITE) {
			color = ST_BLACK;
			stoneModel.glVec(0.0,  1.0, 0.0);
		}
	}

	return;
}

void Stone::setPosition(const fk_Vector &argPos)
{
	stoneModel.glMoveTo(argPos);
}

void Stone::entry(fk_Scene *argScene)
{
	argScene->entryModel(&blackModel);
	argScene->entryModel(&whiteModel);
}

void Stone::remove(fk_Scene *argScene)
{
	argScene->removeModel(&blackModel);
	argScene->removeModel(&whiteModel);
}

// ʒu擾
fk_Vector Stone::getPosition(void)
{
	return stoneModel.getPosition();
}

// F擾
StoneColor Stone::getColor(void)
{
	return color;
}
